{$I DSN.INC}

unit Frm_MainForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, Grids, ImgList, Buttons, Menus, ActnList,
  DBGrids, Mask, DBCtrls, TypInfo,
  ed_Designer, ed_RegComps, edcDsnEvents, ecBtnPanel, edcCompPal,
  edcPropCtrl, ed_RegMeth, edcPropEdit, ecExtEdit, ed_DsnBase, ecDlList, Tst_DataModule,
  dbcgrids, Tst_Frame,
  edsToolObj,   // to avoid AV in ddereg.pas
  {$IFDEF EC_VCL5}
  DsgnIntf;
  {$ELSE}
  DesignIntf, ComponentDesigner;
  {$ENDIF}

type

{$IFDEF EC_VCLD5}
  IProperty = TPropertyEditor;
{$ENDIF}

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Panel1: TPanel;
    StatusBar1: TStatusBar;
    Dsn: TzFormDesigner;
    ImageList1: TImageList;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Button3: TButton;
    PalettePanel1: TPalettePanel;
    Memo1: TMemo;
    ActionList1: TActionList;
    MainMenu1: TMainMenu;
    Test11: TMenuItem;
    Test31: TMenuItem;
    Test41: TMenuItem;
    DesignerEvents1: TDesignerEvents;
    N43: TMenuItem;
    N1: TMenuItem;
    ExitDesigner1: TMenuItem;
    Button5: TButton;
    Bevel1: TBevel;
    Label1: TLabel;
    actTabSheet: TAction;
    actPanel: TAction;
    actForm: TAction;
    actDataModule: TAction;
    actNewForm: TAction;
    actRunMode: TAction;
    Image1: TImage;
    actShowNewForm: TAction;
    N42: TMenuItem;
    NewForm1: TMenuItem;
    Button6: TButton;
    DBNavigator1: TDBNavigator;
    PageControl2: TPageControl;
    TabSheet3: TTabSheet;
    TabSheet4: TTabSheet;
    DBImage1: TDBImage;
    DBMemo1: TDBMemo;
    Label2: TLabel;
    DBEdit1: TDBEdit;
    Label3: TLabel;
    DBEdit2: TDBEdit;
    Label4: TLabel;
    DBEdit3: TDBEdit;
    Label5: TLabel;
    DBEdit4: TDBEdit;
    Label6: TLabel;
    DBEdit5: TDBEdit;
    Panel2: TPanel;
    Edit1: TEdit;
    CheckBox1: TCheckBox;
    RadioButton1: TRadioButton;
    ComboBox1: TComboBox;
    Label7: TLabel;
    Panel3: TPanel;
    Button7: TButton;
    Label8: TLabel;
    Label9: TLabel;
    DBGrid1: TDBGrid;
    DBEdit6: TDBEdit;
    Label10: TLabel;
    Label11: TLabel;
    DBEdit7: TDBEdit;
    DBNavigator2: TDBNavigator;
    DBEdit8: TDBEdit;
    DBEdit9: TDBEdit;
    DBEdit10: TDBEdit;
    Label12: TLabel;
    Label13: TLabel;
    Button8: TButton;
    N44: TMenuItem;
    PropertyEdit2: TPropertyEdit;
    PropertyEdit3: TPropertyEdit;
    PropertyEdit1: TPropertyEdit;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Button9: TButton;
    actFrame: TAction;
    TabSheet5: TTabSheet;
    InspectorList1: TInspectorList;
    Memo2: TMemo;
    TabSheet6: TTabSheet;
    DBCtrlGrid1: TDBCtrlGrid;
    DBCheckBox1: TDBCheckBox;
    DBMemo2: TDBMemo;
    N2: TMenuItem;
    procedure RunDesignerClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    function DesignerEvents1GetGlobalComponents(Root: TComponent;
      const List: TList): Boolean;
    procedure DesignerEvents1ActiveDsnChanged(Sender: TObject);
    procedure DesignerEvents1DsnKeyDown(Sender: IDesigner; var Key: Word;
      Shift: TShiftState);
    procedure DesignerEvents1GetWorkspaceOrigin(Sender: TObject;
      var P: TPoint);
    procedure DsnActiveChanged(Sender: TObject);
    procedure actShowNewFormExecute(Sender: TObject);
    procedure actRunModeExecute(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure InspectorList1AcceptProperty(const PropEdit: IProperty;
      var PropName: WideString; var Accept: Boolean);
    procedure InspectorList1AcceptCategory(Sender: TObject;
      var CategoryName: WideString; var Accept: Boolean);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    NewForm: TForm;
    Frame1: TFrame1;
  public
  end;

var
  Form1: TForm1;

const
  PackagesRegKey = '\Software\EControl\Designer Demo';

implementation

uses edManager, edUtils, eddObjInsp, eddAlignPal, DockForm, StdRegComps,
  Frm_Toolbar, {$IFNDEF EC_VCL5}Frm_ObjTree, {$ENDIF}Frm_ToolPal;

{$R *.DFM}

// Load packages and register Events
procedure TForm1.FormCreate(Sender: TObject);
begin
  Frame1 := TFrame1.Create(Application);
  // Register frame for design-time usage
  PackageMng.RegisterFrame(TFrame1, Frame1);
  with MethRegister do
   begin
    Add(RunDesignerClick);
    Add(FormCreate);
    Add(DesignerEvents1ActiveDsnChanged);
    Add(DsnActiveChanged);
    Add(actShowNewFormExecute);
    Add(actRunModeExecute);
   end;
  // correct work of PropertyEdit2 needs Registering of TPropertyNameProperty
  RegisterPropertyEditor(TypeInfo(string), TPropertyEdit, 'PropertyName', TPropertyNameProperty);
  PropertyEdit2.GetEditor;


  // To Remove Russian text from resource (compatibility with Delphi5)
  Memo2.Lines.Text :=
    'Left='#13#10+
    'Top='#13#10+
    'Hint='#13#10+
    'Font='#13#10+
    'Layout='#13#10+
    'Visual=';

  InspectorList1.OnAcceptProperty := InspectorList1AcceptProperty;

//  PackageMng.ReadRegInfo(PackagesRegKey);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  // Save palette & packages settings into Registry
//  PackageMng.SaveRegInfo(PackagesRegKey);
end;

// Run designer for diferent Targets
procedure TForm1.RunDesignerClick(Sender: TObject);
var p: TPoint;
begin
  Dsn.Active := False;
  case (Sender as TComponent).Tag of
   1: Dsn.Target := TabSheet1;
   2: Dsn.Target := Panel1;
   3: Dsn.Target := Self;
   5: Dsn.Target := DataModule1;
   7: Dsn.Target := Frame1;
   6: begin
       if not Assigned(NewForm) then
       begin
         NewForm := TForm.Create(Application);
         NewForm.Name := 'TestNewForm';
         p := DsnManager.GetWorkspaceOrigin;
         NewForm.Left := p.x;
         NewForm.Top := p.y;
       end;
       Dsn.Target := NewForm;
      end;
  end;
  Dsn.Active := True;
end;

// Set global Components List
function TForm1.DesignerEvents1GetGlobalComponents(Root: TComponent;
  const List: TList): Boolean;
begin
 Result := True;
 List.Add(DataModule1);
end;

// After designer have activated show Toolbar and Object Inspector
procedure TForm1.DesignerEvents1ActiveDsnChanged(Sender: TObject);
begin
  ObjectInspector.Visible := (DsnManager.ActiveDesigner <> nil);
  {$IFNDEF EC_VCL5}
  DsnObjectTree.Visible := (DsnManager.ActiveDesigner <> nil);
  {$ENDIF}
  DsnToolbar.Visible := (DsnManager.ActiveDesigner <> nil);
  CompPalette.Visible := (DsnManager.ActiveDesigner <> nil);
  if (DsnManager.ActiveDesigner = nil) and Assigned(AlignPalette) then
    AlignPalette.Hide;
end;

// Show Toolbar and Object Inspector from keyboard
procedure TForm1.DesignerEvents1DsnKeyDown(Sender: IDesigner;
  var Key: Word; Shift: TShiftState);
begin
 if DsnManager.ActiveDesigner <> nil then
 case Key of
   VK_F11:    ObjectInspector.Show;
   VK_F12:    DsnToolbar.Show;
 end;
end;

// Provide information for DesignWindows positioning
procedure TForm1.DesignerEvents1GetWorkspaceOrigin(Sender: TObject;
  var P: TPoint);
begin
   P := Point(ObjectInspector.Width, DsnToolbar.Height);
end;

procedure TForm1.DsnActiveChanged(Sender: TObject);
begin
  actTabSheet.Enabled := not Dsn.Active;
  actPanel.Enabled := not Dsn.Active;
  actForm.Enabled := not Dsn.Active;
  actDataModule.Enabled := not Dsn.Active;
  actNewForm.Enabled := not Dsn.Active;
  actRunMode.Enabled := Dsn.Active;
  actShowNewForm.Enabled := Assigned(NewForm);
end;

procedure TForm1.actShowNewFormExecute(Sender: TObject);
begin
 if Assigned(NewForm) then
  NewForm.ShowModal;
end;

procedure TForm1.actRunModeExecute(Sender: TObject);
begin
 Dsn.Active := False;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Dsn.Active := False;
end;

// Here an example of alternate way for methods identification
//   not used (alternate way is MethRegister)
{
procedure TForm1.DsnValidateMethod(Sender: TObject; TypeData: PTypeData;
  ARoot: TObject; MethAddr: Pointer; const MethodName: String;
  var Accept: Boolean);
var m: TNotifyEvent;
begin
  Exit;
  Accept := True;
  if TypeData = GetTypeData(TypeInfo(TNotifyEvent)) then
   begin
    m := RunDesignerClick;         if @m = MethAddr then Exit;
    m := FormCreate;               if @m = MethAddr then Exit;
    m := DesignerEvents1ActiveDsnChanged;    if @m = MethAddr then Exit;
    m := DsnActiveChanged;         if @m = MethAddr then Exit;
    m := actShowReportExecute;     if @m = MethAddr then Exit;
    m := actShowNewFormExecute;    if @m = MethAddr then Exit;
    m := actRunModeExecute;        if @m = MethAddr then Exit;
    m := DataModule1.SomeEvent;    if @m = MethAddr then Exit;
   end;
  Accept := False;
end;}

procedure TForm1.InspectorList1AcceptProperty(const PropEdit: IProperty;
  var PropName: WideString; var Accept: Boolean);
var idx: integer;
begin
  idx := Memo2.Lines.IndexOfName(PropName);
  if idx <> -1 then
   begin
    PropName := Memo2.Lines.Values[PropName];
   end;
end;

procedure TForm1.InspectorList1AcceptCategory(Sender: TObject;
  var CategoryName: WideString; var Accept: Boolean);
var idx: integer;
begin
  idx := Memo2.Lines.IndexOfName(CategoryName);
  if idx <> -1 then
   begin
    CategoryName := Memo2.Lines.Values[CategoryName];
   end;
end;

end.
