unit Frm_Toolbar;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, edcCompPal, ExtCtrls, Buttons, edActns, ActnList, ImgList, Menus,
  ToolWin;

type
  TDsnToolbar = class(TForm)
    OD: TOpenDialog;
    OD_F: TOpenDialog;
    SD_F: TSaveDialog;
    ActionList1: TActionList;
    ImageList1: TImageList;
    dsnAlignToGrid1: TdsnAlignToGrid;
    dsnBringToFront1: TdsnBringToFront;
    dsnSendToBack1: TdsnSendToBack;
    dsnAlignmentDlg1: TdsnAlignmentDlg;
    dsnSizeDlg1: TdsnSizeDlg;
    dsnScale1: TdsnScale;
    dsnTabOrderDlg1: TdsnTabOrderDlg;
    dsnCreationOrderDlg1: TdsnCreationOrderDlg;
    dsnFlipChildrenAll1: TdsnFlipChildrenAll;
    dsnFlipChildren1: TdsnFlipChildren;
    dsnCopy1: TdsnCopy;
    dsnCut1: TdsnCut;
    dsnDelete1: TdsnDelete;
    dsnPaste1: TdsnPaste;
    dsnLockControls1: TdsnLockControls;
    dsnSelectAll1: TdsnSelectAll;
    actFileSave: TAction;
    actFileOpen: TAction;
    actAbout: TAction;
    actCustomPack: TAction;
    actDsnProps: TAction;
    actShowPalette: TAction;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Edit1: TMenuItem;
    ools1: TMenuItem;
    actAbout1: TMenuItem;
    Load1: TMenuItem;
    Save1: TMenuItem;
    N1: TMenuItem;
    Disignmode1: TMenuItem;
    Cut1: TMenuItem;
    Copy1: TMenuItem;
    Paste1: TMenuItem;
    Delete1: TMenuItem;
    SelectAll1: TMenuItem;
    N2: TMenuItem;
    Aligntogrid1: TMenuItem;
    Bringtofront1: TMenuItem;
    Sendtoback1: TMenuItem;
    Align1: TMenuItem;
    Size1: TMenuItem;
    Scale1: TMenuItem;
    aborder1: TMenuItem;
    CreationOrder1: TMenuItem;
    FlipChildren1: TMenuItem;
    Flipchildren2: TMenuItem;
    Flipallchildren1: TMenuItem;
    LockControls1: TMenuItem;
    LoadPackage1: TMenuItem;
    DesignerOptions1: TMenuItem;
    AlignPalette1: TMenuItem;
    ControlBar1: TControlBar;
    PaletteTab1: TPaletteTab;
    ToolBar2: TToolBar;
    ToolButton11: TToolButton;
    ToolButton12: TToolButton;
    ToolButton13: TToolButton;
    ToolButton14: TToolButton;
    ToolButton15: TToolButton;
    ToolButton16: TToolButton;
    ToolButton17: TToolButton;
    ToolButton18: TToolButton;
    ToolButton34: TToolButton;
    ToolBar3: TToolBar;
    ToolButton19: TToolButton;
    ToolButton20: TToolButton;
    ToolButton21: TToolButton;
    ToolButton22: TToolButton;
    ToolButton23: TToolButton;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ToolButton5: TToolButton;
    ToolButton6: TToolButton;
    ToolButton7: TToolButton;
    ToolButton8: TToolButton;
    N3: TMenuItem;
    CustomizePalette1: TMenuItem;
    actCustomPalette: TAction;
    actShowInspector: TAction;
    ToolButton10: TToolButton;
    ToolButton9: TToolButton;
    ToolButton24: TToolButton;
    ToolButton25: TToolButton;
    ObjectInspector1: TMenuItem;
    dsnDesignMode1: TdsnDesignMode;
    dsnTextEditMode1: TdsnTextEditMode;
    N4: TMenuItem;
    EditText1: TMenuItem;
    ToolButton26: TToolButton;
    ToolButton27: TToolButton;
    dsnUndo1: TdsnUndo;
    dsnRedo1: TdsnRedo;
    ToolButton28: TToolButton;
    ToolButton29: TToolButton;
    ToolButton30: TToolButton;
    procedure FormCreate(Sender: TObject);
    procedure AboutClick(Sender: TObject);
    procedure AlignPalClick(Sender: TObject);
    procedure DsnPropsClick(Sender: TObject);
    procedure OpenClick(Sender: TObject);
    procedure SaveClick(Sender: TObject);
    procedure actShowPaletteUpdate(Sender: TObject);
    procedure ControlBar1BandMove(Sender: TObject; Control: TControl;
      var ARect: TRect);
    procedure ControlBar1Resize(Sender: TObject);
    procedure FormCanResize(Sender: TObject; var NewWidth,
      NewHeight: Integer; var Resize: Boolean);
    procedure actCustomPackExecute(Sender: TObject);
    procedure actCustomPaletteExecute(Sender: TObject);
    procedure actShowInspectorExecute(Sender: TObject);
    procedure actShowInspectorUpdate(Sender: TObject);
  private
    procedure ReadError(Reader: TReader; const Message: string;
      var Handled: Boolean);
  public
    { Public declarations }
  end;

var
  DsnToolbar: TDsnToolbar;

implementation

uses ed_RegComps, edUtils, edManager, eddAlignPal, eddObjInsp;

{$R *.DFM}

procedure TDsnToolbar.FormCreate(Sender: TObject);
begin
  Left:= 0;
  Top := 0;
  Width := Screen.Width;
end;

procedure TDsnToolbar.AboutClick(Sender: TObject);
begin
 ShowDsnAbout;
end;

procedure TDsnToolbar.AlignPalClick(Sender: TObject);
begin
  if DsnManager.ActiveDesigner <> nil then
    begin
      if not Assigned(AlignPalette) then
        AlignPalette := TAlignPalette.Create(Self);
      AlignPalette.Visible := not AlignPalette.Visible;
    end;
end;

procedure TDsnToolbar.DsnPropsClick(Sender: TObject);
begin
  ShowDesignerOptionsDlg(nil);
end;

procedure TDsnToolbar.ReadError(Reader: TReader; const Message: string; var Handled: Boolean);
begin
  Handled := True;
end;

procedure TDsnToolbar.OpenClick(Sender: TObject);
begin
  if OD_F.Execute then
    DsnReadFromFile(OD_F.FileName, nil, ReadError);
end;

procedure TDsnToolbar.SaveClick(Sender: TObject);
begin
  if SD_F.Execute then
   DsnWriteToFile(SD_F.FileName, nil, True);
end;

procedure TDsnToolbar.actShowPaletteUpdate(Sender: TObject);
begin
  actShowPalette.Checked := Assigned(AlignPalette) and AlignPalette.Visible;
end;

procedure TDsnToolbar.ControlBar1BandMove(Sender: TObject;
  Control: TControl; var ARect: TRect);
begin
  if Control = PaletteTab1 then
   ARect.Right := ControlBar1.ClientWidth;
end;

procedure TDsnToolbar.ControlBar1Resize(Sender: TObject);
begin
  ClientHeight := ControlBar1.Height;
end;

procedure TDsnToolbar.FormCanResize(Sender: TObject; var NewWidth,
  NewHeight: Integer; var Resize: Boolean);
begin
  NewHeight := ControlBar1.Height + Height - ClientHeight;
end;

procedure TDsnToolbar.actCustomPackExecute(Sender: TObject);
begin
  PackageMng.CustomizePackages;
end;

procedure TDsnToolbar.actCustomPaletteExecute(Sender: TObject);
begin
  PackageMng.CustomizePalette;
end;

procedure TDsnToolbar.actShowInspectorExecute(Sender: TObject);
begin
  ObjectInspector.Visible := not ObjectInspector.Visible;
end;

procedure TDsnToolbar.actShowInspectorUpdate(Sender: TObject);
begin
  actShowInspector.Checked := ObjectInspector.Visible;
end;

end.
