{ *************************************************************************** }
{                                                                             }
{ EControl Form Designer Pro                                                  }
{                                                                             }
{ Copyright (c) 2004 - 2009 EControl Ltd.                                     }
{     www.econtrol.ru                                                         }
{     support@econtrol.ru                                                     }
{                                                                             }
{ *************************************************************************** }
{$I DSN.INC}

unit StdRegComps;

interface

{$DEFINE FD_REGISTER_STD}
{$DEFINE FD_REGISTER_STD_EDITORS}
{$DEFINE FD_REGISTER_STD_ACTIONS}
{$DEFINE FD_REGISTER_DDE}
{$DEFINE FD_REGISTER_DB}
{$DEFINE FD_REGISTER_BDE}
{$DEFINE FD_REGISTER_ADO}
{.$DEFINE FD_REGISTER_ECONTROL_SYNTEDIT}
{.$DEFINE FD_REGISTER_ECONTROL_FORMDESIGNER}
{.$DEFINE FD_REGISTER_DEVEX_GRIDS}
{.$DEFINE FD_REGISTER_DEVEX_EDITS}

{$IFDEF EC_VCL10_UP}
  {$IFDEF BCB}
    {$UNDEF FD_REGISTER_DB}
    {$UNDEF FD_REGISTER_BDE}
    {$UNDEF FD_REGISTER_ADO}
  {$ENDIF}
{$ENDIF}

{$IFDEF EC_VCL5}
  {$UNDEF FD_REGISTER_STD_ACTIONS}
{$ENDIF}

 procedure StandardRegister;

implementation

  uses DsnConst,
{$IFNDEF EC_NO_BPL}
      ed_RegComps, // to ensure creating parckage manager first
    {$IFDEF FD_REGISTER_STD}
      edsToolObj,   // to avoid AV in ddereg.pas
    {$ENDIF}
      edUtils;
  // Registration with runtime packages does not require direct access to libraries
  // registration methods. Registration performed automatically when loading package
  // using DsnLoadPackage procedure.
{$ELSE}
    {$IFDEF FD_REGISTER_STD}
      Classes, Graphics, Controls, Forms, Dialogs, ComCtrls,
      Menus, StdCtrls, ImgList, Buttons, ExtCtrls, Tabs, ExtDlgs, Mask,
      Grids, CheckLst, AppEvnts, MPlayer, OleCtnrs,
      ActnList, StdActns,
    {$ENDIF}
    {$IFDEF EC_VCL6_UP}
    ActnRes, ExtActns,
    {$ENDIF}
    {$IFDEF FD_REGISTER_STD_EDITORS}
      StdDsnEditors,
    {$ENDIF}
    {$IFDEF FD_REGISTER_DDE}
      edsToolObj,   // to avoid AV in ddereg.pas
      DdeMan,
    {$ENDIF}
    {$IFDEF FD_REGISTER_DB}
      dbreg,
      DBGrids, DBCtrls, DBCGrids,
    {$ENDIF}
    {$IFDEF FD_REGISTER_BDE}
      bdereg,
    {$ENDIF}
    {$IFDEF FD_REGISTER_ADO}
      adoreg,
    {$ENDIF}
    {$IFDEF FD_REGISTER_DEVEX_EDITS}
      cxEditReg, cxExtEditReg,
    {$ENDIF}
    {$IFDEF FD_REGISTER_DEVEX_GRIDS}
      cxGridReg, cxGridPopupMenuReg,
    {$ENDIF}
//     {$IFDEF EC_BCB}
//     DsnDbCst, Events,
//     {$ENDIF}
    {$IFDEF FD_REGISTER_ECONTROL_SYNTEDIT}
      ecComnReg, ecSyntCEreg, ecSyntReg,
    {$ENDIF}
    {$IFDEF FD_REGISTER_ECONTROL_FORMDESIGNER}
      edReg,
    {$ENDIF}
    {$IFDEF EC_VCL5} DsgnIntf {$ELSE} DesignEditors, DesignIntf {$ENDIF};

    // component icons linking
    {$IFDEF FD_REGISTER_STD}
      {$R DclStd.res}
    {$ENDIF}

    {$IFDEF FD_REGISTER_DB}
      {$R DclDb.res}
    {$ENDIF}

    {$IFDEF FD_REGISTER_BDE}
      {$R DclBde.res}
    {$ENDIF}

    {$IFDEF FD_REGISTER_ADO}
      {$R DclAdo.res}
    {$ENDIF}

    {$IFDEF FD_REGISTER_DEVEX_EDITS}
      {$R cxEditReg.dcr}
      {$R cxExtEditReg.dcr}
    {$ENDIF}

    {$IFDEF FD_REGISTER_DEVEX_GRIDS}
      {$R cxGridReg.dcr}
      {$R cxGridPopupMenuReg.dcr}
    {$ENDIF}
{$ENDIF}

{$IFNDEF EC_NO_BPL}
procedure StandardRegister;
begin
  // Delphi 5
  {$IFDEF EC_VCL5}
      {$IFDEF FD_REGISTER_STD}
       DsnLoadPackage('dclstd50.bpl');
      {$ENDIF}
      {$IFDEF FD_REGISTER_STD_EDITORS}
       DsnLoadPackage('dsnide50.bpl');
      {$ENDIF}
      {$IFDEF FD_REGISTER_DB}
       DsnLoadPackage('dcldb50.bpl');
       DsnLoadPackage('dclqrt50.bpl');
      {$ENDIF}
      {$IFDEF FD_REGISTER_BDE}
       DsnLoadPackage('dclbde50.bpl');
     {$ENDIF}
      {$IFDEF FD_REGISTER_ADO}
       DsnLoadPackage('dclado50.bpl');
      {$ENDIF}
      // C++Builder 5
      {$IFDEF BCB}
          {$IFDEF FD_REGISTER_ECONTROL_SYNTEDIT}
           DsnLoadPackage('ecComnC5.bpl');
           DsnLoadPackage('SyntEditDcl5c.bpl');
          {$ENDIF}
          {$IFDEF FD_REGISTER_ECONTROL_FORMDESIGNER}
           DsnLoadPackage('zDesignC5.bpl');
          {$ENDIF}
          {$IFDEF FD_REGISTER_DEVEX_EDITS}
           DsnLoadPackage('dclcxEditorsC5.bpl');
           DsnLoadPackage('dclcxExtEditorsC5.bpl');
          {$ENDIF}
          {$IFDEF FD_REGISTER_DEVEX_GRIDS}
           DsnLoadPackage('dclcxGridC5.bpl');
          {$ENDIF}
      {$ELSE}  // Delphi 5
          {$IFDEF FD_REGISTER_ECONTROL_SYNTEDIT}
           DsnLoadPackage('ecComnD5.bpl');
           DsnLoadPackage('SyntEditDcl5.bpl');
          {$ENDIF}
          {$IFDEF FD_REGISTER_ECONTROL_FORMDESIGNER}
           DsnLoadPackage('zDesign5.bpl');
          {$ENDIF}
          {$IFDEF FD_REGISTER_DEVEX_EDITS}
           DsnLoadPackage('dclcxEditorsD5.bpl');
           DsnLoadPackage('dclcxExtEditorsD5.bpl');
          {$ENDIF}
          {$IFDEF FD_REGISTER_DEVEX_GRIDS}
           DsnLoadPackage('dclcxGridD5.bpl');
          {$ENDIF}
      {$ENDIF}
  {$ELSE}
  // Delphi 6
  {$IFDEF EC_VCL6}
      {$IFDEF FD_REGISTER_STD}
       DsnLoadPackage('dclstd60.bpl');
      {$ENDIF}
      {$IFDEF FD_REGISTER_STD_EDITORS}
       DsnLoadPackage('designide60.bpl');
      {$ENDIF}
      {$IFDEF FD_REGISTER_DB}
       DsnLoadPackage('dcldb60.bpl');
       DsnLoadPackage('dclqrt60.bpl');
      {$ENDIF}
      {$IFDEF FD_REGISTER_BDE}
       DsnLoadPackage('dclbde60.bpl');
      {$ENDIF}
      {$IFDEF FD_REGISTER_ADO}
       DsnLoadPackage('dclado60.bpl');
      {$ENDIF}
      {$IFDEF BCB} // C++ Builder 6
          {$IFDEF FD_REGISTER_ECONTROL_SYNTEDIT}
           DsnLoadPackage('ecComnC6.bpl');
           DsnLoadPackage('SyntEditDcl6c.bpl');
          {$ENDIF}
          {$IFDEF FD_REGISTER_ECONTROL_FORMDESIGNER}
           DsnLoadPackage('zDesignC6.bpl');
          {$ENDIF}
          {$IFDEF FD_REGISTER_DEVEX_EDITS}
           DsnLoadPackage('dclcxEditorsVCLC6.bpl');
           DsnLoadPackage('dclcxExtEditorsVCLC6.bpl');
          {$ENDIF}
          {$IFDEF FD_REGISTER_DEVEX_GRIDS}
           DsnLoadPackage('dclcxGridVCLC6.bpl');
          {$ENDIF}
      {$ELSE} // Delphi 6
          {$IFDEF FD_REGISTER_ECONTROL_SYNTEDIT}
           DsnLoadPackage('ecComnD6.bpl');
           DsnLoadPackage('SyntEditDcl6.bpl');
          {$ENDIF}
          {$IFDEF FD_REGISTER_ECONTROL_FORMDESIGNER}
           DsnLoadPackage('zDesign6.bpl');
          {$ENDIF}
          {$IFDEF FD_REGISTER_DEVEX_EDITS}
           DsnLoadPackage('dclcxEditorsVCLD6.bpl');
           DsnLoadPackage('dclcxExtEditorsVCLD6.bpl');
          {$ENDIF}
          {$IFDEF FD_REGISTER_DEVEX_GRIDS}
           DsnLoadPackage('dclcxGridVCLD6.bpl');
          {$ENDIF}
      {$ENDIF}
  {$ELSE}
  // Delphi 7
  {$IFDEF EC_VCL7}
      {$IFDEF FD_REGISTER_STD}
       DsnLoadPackage('dclstd70.bpl');
      {$ENDIF}
      {$IFDEF FD_REGISTER_STD_EDITORS}
       DsnLoadPackage('vcldesigner70.bpl');
      {$ENDIF}
      {$IFDEF FD_REGISTER_DB}
       DsnLoadPackage('dcldb70.bpl');
       DsnLoadPackage('dclqrt70.bpl');
      {$ENDIF}
      {$IFDEF FD_REGISTER_BDE}
       DsnLoadPackage('dclbde70.bpl');
      {$ENDIF}
      {$IFDEF FD_REGISTER_ADO}
       DsnLoadPackage('dclado70.bpl');
      {$ENDIF}
      {$IFDEF FD_REGISTER_ECONTROL_SYNTEDIT}
       DsnLoadPackage('ecComnD7.bpl');
       DsnLoadPackage('SyntEditDcl7.bpl');
      {$ENDIF}
      {$IFDEF FD_REGISTER_ECONTROL_FORMDESIGNER}
       DsnLoadPackage('zDesign7.bpl');
      {$ENDIF}
      {$IFDEF FD_REGISTER_DEVEX_EDITS}
       DsnLoadPackage('dclcxEditorsVCLD7.bpl');
       DsnLoadPackage('dclcxExtEditorsVCLD7.bpl');
      {$ENDIF}
      {$IFDEF FD_REGISTER_DEVEX_GRIDS}
       DsnLoadPackage('dclcxGridVCLD7.bpl');
      {$ENDIF}
  {$ELSE}
  // Delphi 2005
  {$IFDEF EC_VCL9}
      {$IFDEF FD_REGISTER_STD}
       DsnLoadPackage('dclstd90.bpl');
      {$ENDIF}
      {$IFDEF FD_REGISTER_STD_EDITORS}
       DsnLoadPackage('vcldesigner90.bpl');
      {$ENDIF}
      {$IFDEF FD_REGISTER_DB}
       DsnLoadPackage('dcldb90.bpl');
  //     DsnLoadPackage('dclqrt90.bpl');
      {$ENDIF}
      {$IFDEF FD_REGISTER_BDE}
       DsnLoadPackage('dclbde90.bpl');
      {$ENDIF}
      {$IFDEF FD_REGISTER_ADO}
       DsnLoadPackage('dclado90.bpl');
      {$ENDIF}
      {$IFDEF FD_REGISTER_ECONTROL_SYNTEDIT}
       DsnLoadPackage('ecComnD9.bpl');
       DsnLoadPackage('SyntEditDcl9.bpl');
      {$ENDIF}
      {$IFDEF FD_REGISTER_ECONTROL_FORMDESIGNER}
       DsnLoadPackage('zDesign9.bpl');
      {$ENDIF}
      {$IFDEF FD_REGISTER_DEVEX_EDITS}
       DsnLoadPackage('dclcxEditorsVCLD9.bpl');
       DsnLoadPackage('dclcxExtEditorsVCLD9.bpl');
      {$ENDIF}
      {$IFDEF FD_REGISTER_DEVEX_GRIDS}
       DsnLoadPackage('dclcxGridVCLD9.bpl');
      {$ENDIF}
  {$ELSE}
  // Delphi 2006
  {$IFDEF EC_VCL10}
      {$IFDEF FD_REGISTER_STD}
       DsnLoadPackage('dclstd100.bpl');
      {$ENDIF}
      {$IFDEF FD_REGISTER_STD_EDITORS}
       DsnLoadPackage('vcldesigner100.bpl');
      {$ENDIF}
      {$IFDEF FD_REGISTER_DB}
       DsnLoadPackage('dcldb100.bpl');
  //     DsnLoadPackage('dclqrt100.bpl');
      {$ENDIF}
      {$IFDEF FD_REGISTER_BDE}
       DsnLoadPackage('dclbde100.bpl');
      {$ENDIF}
      {$IFDEF FD_REGISTER_ADO}
       DsnLoadPackage('dclado100.bpl');
      {$ENDIF}
      // C++Builder 2006
      {$IFDEF BCB}
          {$IFDEF FD_REGISTER_ECONTROL_SYNTEDIT}
           DsnLoadPackage('ecComnC10.bpl');
           DsnLoadPackage('SyntEditDcl10c.bpl');
          {$ENDIF}
          {$IFDEF FD_REGISTER_ECONTROL_FORMDESIGNER}
           DsnLoadPackage('zDesignC10.bpl');
          {$ENDIF}
          {$IFDEF FD_REGISTER_DEVEX_EDITS}
           DsnLoadPackage('dclcxEditorsC10.bpl');
           DsnLoadPackage('dclcxExtEditorsC10.bpl');
          {$ENDIF}
          {$IFDEF FD_REGISTER_DEVEX_GRIDS}
           DsnLoadPackage('dclcxGridC10.bpl');
          {$ENDIF}
      {$ELSE}  // Delphi 2006
          {$IFDEF FD_REGISTER_ECONTROL_SYNTEDIT}
           DsnLoadPackage('ecComnD10.bpl');
           DsnLoadPackage('SyntEditDcl10.bpl');
          {$ENDIF}
          {$IFDEF FD_REGISTER_ECONTROL_FORMDESIGNER}
           DsnLoadPackage('zDesign10.bpl');
          {$ENDIF}
          {$IFDEF FD_REGISTER_DEVEX_EDITS}
           DsnLoadPackage('dclcxEditorsD10.bpl');
           DsnLoadPackage('dclcxExtEditorsD10.bpl');
          {$ENDIF}
          {$IFDEF FD_REGISTER_DEVEX_GRIDS}
           DsnLoadPackage('dclcxGridD10.bpl');
          {$ENDIF}
      {$ENDIF}
  {$ELSE}
  // Delphi 2007
  {$IFDEF EC_VCL11}
      {$IFDEF FD_REGISTER_STD}
       DsnLoadPackage('dclstd110.bpl');
      {$ENDIF}
      {$IFDEF FD_REGISTER_STD_EDITORS}
       DsnLoadPackage('vcldesigner110.bpl');
      {$ENDIF}
      {$IFDEF FD_REGISTER_DB}
       DsnLoadPackage('dcldb110.bpl');
  //     DsnLoadPackage('dclqrt110.bpl');
      {$ENDIF}
      {$IFDEF FD_REGISTER_BDE}
       DsnLoadPackage('dclbde110.bpl');
      {$ENDIF}
      {$IFDEF FD_REGISTER_ADO}
       DsnLoadPackage('dclado110.bpl');
      {$ENDIF}
      // C++Builder 2007
      {$IFDEF BCB}
          {$IFDEF FD_REGISTER_ECONTROL_SYNTEDIT}
           DsnLoadPackage('ecComnC11.bpl');
           DsnLoadPackage('SyntEditDcl11c.bpl');
          {$ENDIF}
          {$IFDEF FD_REGISTER_ECONTROL_FORMDESIGNER}
           DsnLoadPackage('zDesignC11.bpl');
          {$ENDIF}
          {$IFDEF FD_REGISTER_DEVEX_EDITS}
           DsnLoadPackage('dclcxEditorsC11.bpl');
           DsnLoadPackage('dclcxExtEditorsC11.bpl');
          {$ENDIF}
          {$IFDEF FD_REGISTER_DEVEX_GRIDS}
           DsnLoadPackage('dclcxGridC11.bpl');
          {$ENDIF}
      {$ELSE}  // Delphi 2007
          {$IFDEF FD_REGISTER_ECONTROL_SYNTEDIT}
           DsnLoadPackage('ecComnD11.bpl');
           DsnLoadPackage('SyntEditDcl11.bpl');
          {$ENDIF}
          {$IFDEF FD_REGISTER_ECONTROL_FORMDESIGNER}
           DsnLoadPackage('zDesign11.bpl');
          {$ENDIF}
          {$IFDEF FD_REGISTER_DEVEX_EDITS}
           DsnLoadPackage('dclcxEditorsD11.bpl');
           DsnLoadPackage('dclcxExtEditorsD11.bpl');
          {$ENDIF}
          {$IFDEF FD_REGISTER_DEVEX_GRIDS}
           DsnLoadPackage('dclcxGridD11.bpl');
          {$ENDIF}
      {$ENDIF}
  {$ELSE}
  // Delphi 2009
  {$IFDEF EC_VCL12}
      {$IFDEF FD_REGISTER_STD}
       DsnLoadPackage('dclstd120.bpl');
      {$ENDIF}
      {$IFDEF FD_REGISTER_STD_EDITORS}
       DsnLoadPackage('vcldesigner120.bpl');
      {$ENDIF}
      {$IFDEF FD_REGISTER_DB}
       DsnLoadPackage('dcldb120.bpl');
  //     DsnLoadPackage('dclqrt120.bpl');
      {$ENDIF}
      {$IFDEF FD_REGISTER_BDE}
       DsnLoadPackage('dclbde120.bpl');
      {$ENDIF}
      {$IFDEF FD_REGISTER_ADO}
       DsnLoadPackage('dclado120.bpl');
      {$ENDIF}
      // C++Builder 2007
      {$IFDEF BCB}
          {$IFDEF FD_REGISTER_ECONTROL_SYNTEDIT}
           DsnLoadPackage('ecComnC12.bpl');
           DsnLoadPackage('SyntEditDcl12c.bpl');
          {$ENDIF}
          {$IFDEF FD_REGISTER_ECONTROL_FORMDESIGNER}
           DsnLoadPackage('zDesignC12.bpl');
          {$ENDIF}
          {$IFDEF FD_REGISTER_DEVEX_EDITS}
           DsnLoadPackage('dclcxEditorsC12.bpl');
           DsnLoadPackage('dclcxExtEditorsC12.bpl');
          {$ENDIF}
          {$IFDEF FD_REGISTER_DEVEX_GRIDS}
           DsnLoadPackage('dclcxGridC12.bpl');
          {$ENDIF}
      {$ELSE}  // Delphi 2007
          {$IFDEF FD_REGISTER_ECONTROL_SYNTEDIT}
           DsnLoadPackage('ecComnD12.bpl');
           DsnLoadPackage('SyntEditDcl12.bpl');
          {$ENDIF}
          {$IFDEF FD_REGISTER_ECONTROL_FORMDESIGNER}
           DsnLoadPackage('zDesign12.bpl');
          {$ENDIF}
          {$IFDEF FD_REGISTER_DEVEX_EDITS}
           DsnLoadPackage('dclcxEditorsD12.bpl');
           DsnLoadPackage('dclcxExtEditorsD12.bpl');
          {$ENDIF}
          {$IFDEF FD_REGISTER_DEVEX_GRIDS}
           DsnLoadPackage('dclcxGridD12.bpl');
          {$ENDIF}
      {$ENDIF}
  {$ELSE}
  // Delphi 2010
  {$IFDEF EC_VCL14}
      {$IFDEF FD_REGISTER_STD}
       DsnLoadPackage('dclstd140.bpl');
      {$ENDIF}
      {$IFDEF FD_REGISTER_STD_EDITORS}
       DsnLoadPackage('vcldesigner140.bpl');
      {$ENDIF}
      {$IFDEF FD_REGISTER_DB}
       DsnLoadPackage('dcldb140.bpl');
  //     DsnLoadPackage('dclqrt130.bpl');
      {$ENDIF}
      {$IFDEF FD_REGISTER_BDE}
       DsnLoadPackage('dclbde140.bpl');
      {$ENDIF}
      {$IFDEF FD_REGISTER_ADO}
       DsnLoadPackage('dclado140.bpl');
      {$ENDIF}
      // C++Builder 2010
      {$IFDEF BCB}
          {$IFDEF FD_REGISTER_ECONTROL_SYNTEDIT}
           DsnLoadPackage('ecComnC14.bpl');
           DsnLoadPackage('SyntEditDcl14c.bpl');
          {$ENDIF}
          {$IFDEF FD_REGISTER_ECONTROL_FORMDESIGNER}
           DsnLoadPackage('zDesignC14.bpl');
          {$ENDIF}
          {$IFDEF FD_REGISTER_DEVEX_EDITS}
           DsnLoadPackage('dclcxEditorsC14.bpl');
           DsnLoadPackage('dclcxExtEditorsC14.bpl');
          {$ENDIF}
          {$IFDEF FD_REGISTER_DEVEX_GRIDS}
           DsnLoadPackage('dclcxGridC14.bpl');
          {$ENDIF}
      {$ELSE}  // Delphi 2010
          {$IFDEF FD_REGISTER_ECONTROL_SYNTEDIT}
           DsnLoadPackage('ecComnD14.bpl');
           DsnLoadPackage('SyntEditDcl14.bpl');
          {$ENDIF}
          {$IFDEF FD_REGISTER_ECONTROL_FORMDESIGNER}
           DsnLoadPackage('zDesign14.bpl');
          {$ENDIF}
          {$IFDEF FD_REGISTER_DEVEX_EDITS}
           DsnLoadPackage('dclcxEditorsD14.bpl');
           DsnLoadPackage('dclcxExtEditorsD14.bpl');
          {$ENDIF}
          {$IFDEF FD_REGISTER_DEVEX_GRIDS}
           DsnLoadPackage('dclcxGridD14.bpl');
          {$ENDIF}
      {$ENDIF}
  {$ENDIF}
  {$ENDIF}
  {$ENDIF}
  {$ENDIF}
  {$ENDIF}
  {$ENDIF}
  {$ENDIF}
  {$ENDIF}
end;

{$ELSE}
procedure StandardRegister;
begin
{$IFDEF FD_REGISTER_STD}
  RegisterComponents(srStandard, [TMainMenu, TPopupMenu, TLabel, TEdit,
    TMemo, TButton, TCheckBox, TRadioButton, TListBox, TComboBox, TScrollBar,
    TGroupBox, TRadioGroup, TPanel, TActionList]);
  RegisterNoIcon([TMenuItem]);
  RegisterComponents(srAdditional, [TBitBtn, TSpeedButton, TMaskEdit, TStringGrid,
    TDrawGrid, TImage, TShape, TBevel, TScrollBox, TCheckListBox, TSplitter,
    TStaticText, TControlBar, TApplicationEvents]);
  RegisterComponents(srWin95, [TTabControl, TPageControl, TImageList, TRichEdit,
    TTrackBar, TProgressBar, TUpDown, THotKey, TAnimate, TDateTimePicker,
    TMonthCalendar, TTreeView, TListView, THeaderControl, TStatusBar, TToolBar,
    TCoolBar, TPageScroller]);
  RegisterClasses([TToolButton, TTabSheet]);
  RegisterComponents(srSystem, [TTimer, TPaintBox, TMediaPlayer, TOleContainer]);
  RegisterComponents(srDialogs, [TOpenDialog, TSaveDialog, TOpenPictureDialog,
    TSavePictureDialog, TFontDialog, TColorDialog, TPrintDialog, TPrinterSetupDialog,
    TFindDialog, TReplaceDialog]);

  {$IFNDEF EC_VCL5}
  RegisterPropertiesInCategory('Action',
      ['Action', 'Caption', 'Checked', 'Enabled', 'HelpContext', 'Hint', 'ImageIndex',
       'ShortCut', 'Visible']);
  RegisterPropertiesInCategory('Drag, Drop and Docking',
      ['Drag*', 'Dock*', 'UseDockManager', 'OnDockOver', 'OnGetSiteInfo', 'OnDragOver', 'On*Drop',
       'On*Drag', 'On*Dock']);
  RegisterPropertiesInCategory('Help and Hints', ['Help*', '*Help', 'Hint*', '*Hint']);
  RegisterPropertiesInCategory('Layout', ['Left', 'Top', 'Width', 'Height', 'TabOrder',
        'TabStop', 'Align', 'Anchors', 'Constraints', 'AutoSize', 'AutoScroll', 'Scaled',
        'OnResize', 'OnConstrained', 'OnCanResize']);
  RegisterPropertiesInCategory('Legacy', ['Ctl3d', 'ParentCtl3d', 'OldCreateOrder']);
  RegisterPropertiesInCategory('Linkage', TypeInfo(TComponent), ['']);
  RegisterPropertiesInCategory('Linkage', TypeInfo(IInterface), ['']);
  RegisterPropertiesInCategory('Visual', ['Left','Top','Width','Height','Visible',
        'Enabled','Caption','Align','Alignment','ParentColor','ParentFont','Bevel*',
        'Border*','ClientHeight','ClientWidth','Scaled','AutoSize','EditMask','OnShow',
        'OnPaint','OnClose','OnCloseQuery','OnResize','OnConstrained','OnActivate',
        'OnDeactivate','OnCanResize','OnHide']);
  RegisterPropertiesInCategory('Visual', TypeInfo(TFont), ['']);
  RegisterPropertiesInCategory('Visual', TypeInfo(TColor), ['']);
  RegisterPropertiesInCategory('Visual', TypeInfo(TBrush), ['']);
  RegisterPropertiesInCategory('Visual', TypeInfo(TPen), ['']);
  RegisterPropertiesInCategory('Visual', TypeInfo(TCursor), ['']);
  RegisterPropertiesInCategory('Visual', TypeInfo(TGraphic), ['']);
  RegisterPropertiesInCategory('Input', ['AutoScroll','KeyPreview','ReadOnly',
        'Enabled','OnClick','OnDblClick','OnShortCut','OnKey*','OnMouse*']);

  RegisterPropertiesInCategory('Localizable', ['BiDiMode','Caption','Constraints',
        'EditMask','Glyph','Height','Hint','Icon','ImeMode','ImeName','Left',
        'ParentBiDiMode','ParentFont','Picture','Text','Top','Width']);
  RegisterPropertiesInCategory('Localizable', TCustomForm, ['ClientHeight',
        'ClientWidth','HelpFile']);
  RegisterPropertiesInCategory('Localizable', THotKey, ['Hotkey']);
  RegisterPropertiesInCategory('Localizable', TMainMenu, ['Items']);
  RegisterPropertiesInCategory('Localizable', TPopupMenu, ['Hotkey']);
  RegisterPropertiesInCategory('Localizable', TSplitter, ['MinSize']);
  RegisterPropertiesInCategory('Localizable', TCustomEdit, ['PasswordChar']);
  RegisterPropertiesInCategory('Localizable', TStatusBar, ['SimpleText']);
  RegisterPropertiesInCategory('Localizable', TMenuItem, ['ShortCut']);
  RegisterPropertiesInCategory('Localizable', TSpeedButton, ['Margin','Spacing']);
  RegisterPropertiesInCategory('Localizable', TAction, ['Category','ShortCut']);
  RegisterPropertiesInCategory('Localizable', TRadioGroup, ['Columns']);
  RegisterPropertiesInCategory('Localizable', TToolBar, ['ButtonHeight','ButtonWidth']);
  RegisterPropertiesInCategory('Localizable', TCustomMemo, ['Lines']);
  RegisterPropertiesInCategory('Localizable', TCustomRadioGroup, ['Items']);
  RegisterPropertiesInCategory('Localizable', TCustomComboBox, ['Items']);
  RegisterPropertiesInCategory('Localizable', TCustomListBox, ['Items']);
  RegisterPropertiesInCategory('Localizable', TCustomTabControl, ['Tabs']);
  RegisterPropertiesInCategory('Localizable', TTabSet, ['Tabs']);

  RegisterPropertiesInCategory('Localizable', TypeInfo(TListColumns), ['']);
  RegisterPropertiesInCategory('Localizable', TypeInfo(TListItems), ['']);
  RegisterPropertiesInCategory('Localizable', TypeInfo(TStatusPanels), ['']);
  RegisterPropertiesInCategory('Localizable', TypeInfo(TTreeNodes), ['']);
  RegisterPropertiesInCategory('Localizable', TypeInfo(THeaderSections), ['']);
  RegisterPropertiesInCategory('Localizable', TypeInfo(TImageList), ['']);
  RegisterPropertiesInCategory('Localizable', TypeInfo(TSizeConstraints), ['']);
  RegisterPropertiesInCategory('Localizable', TypeInfo(TFont), ['']);

  RegisterPropertiesInCategory('Localizable', TFindDialog, ['FindText']);
  RegisterPropertiesInCategory('Localizable', TReplaceDialog, ['FindText']);
  RegisterPropertiesInCategory('Localizable', TReplaceDialog, ['ReplaceText']);
  RegisterPropertiesInCategory('Localizable', TOpenDialog, ['Filter']);
  RegisterPropertiesInCategory('Localizable', TOpenDialog, ['Title']);
  RegisterPropertiesInCategory('Localizable', TSaveDialog, ['Filter']);
  RegisterPropertiesInCategory('Localizable', TSaveDialog, ['Title']);
  RegisterPropertiesInCategory('Localizable', TOpenPictureDialog, ['Filter']);
  RegisterPropertiesInCategory('Localizable', TOpenPictureDialog, ['Title']);
  RegisterPropertiesInCategory('Localizable', TSavePictureDialog, ['Filter']);
  RegisterPropertiesInCategory('Localizable', TSavePictureDialog, ['Title']);
  {$ENDIF}

  {$IFDEF FD_REGISTER_STD_ACTIONS}
  // Registration standard actions
  RegisterActions(SEditCategory, [TEditCopy, TEditCut, TEditPaste, TEditDelete, TEditUndo,
    TEditSelectAll], TStandardActions);
  RegisterActions(SFormat, [TRichEditBold, TRichEditItalic, TRichEditUnderline,
    TRichEditStrikeOut, TRichEditBullets, TRichEditAlignLeft, TRichEditAlignRight,
    TRichEditAlignCenter], TStandardActions);
  RegisterActions(SHelpCategory, [THelpContents, THelpTopicSearch, THelpOnHelp,
    THelpContextAction], TStandardActions);
  RegisterActions(SWindowCategory, [TWindowClose, TWindowCascade, TWindowTileHorizontal,
    TWindowTileVertical, TWindowMinimizeAll, TWindowArrange], TStandardActions);
  RegisterActions(SDialogCategory, [TFileRun, TFileOpen, TFileOpenWith, TFileSaveAs,
    TFilePrintSetup, TFilePageSetup, TFileExit{$IFDEF EC_VCL9_UP}, TBrowseForFolder{$ENDIF}], TStandardActions);
  RegisterActions(SSearchCategory, [TSearchFind, TSearchReplace, TSearchFindFirst,
    TSearchFindNext], TStandardActions);
  RegisterActions(STabCategory, [TNextTab, TPreviousTab], TStandardActions);
  RegisterActions(SListCategory, [TListControlSelectAll, TListControlClearSelection,
    TListControlDeleteSelection, TListControlCopySelection,
    TListControlMoveSelection], TStandardActions);
  RegisterActions(SDialogCategory, [TColorSelect, TFontEdit, TOpenPicture,
    TSavePicture, TPrintDlg], TStandardActions);
  RegisterActions(SInternetCategory, [TBrowseURL, TDownLoadURL, TSendMail], TStandardActions);
  {$ENDIF}
{$ENDIF}

{$IFDEF FD_REGISTER_STD_EDITORS}
  StdDsnEditors.Register;
{$ENDIF}

{$IFDEF FD_REGISTER_DDE}
  RegisterComponents(srSystem, [TDDEClientConv, TDDEClientItem, TDDEServerConv, TDDEServerItem]);
{$ENDIF}

{$IFDEF FD_REGISTER_DB}
  RegisterComponents('Data Controls', [TDBGrid, TDBNavigator, TDBText, TDBEdit,
    TDBMemo, TDBImage, TDBListBox, TDBComboBox, TDBCheckBox, TDBRadioGroup,
    TDBLookupListBox, TDBLookupComboBox, TDBRichEdit, TDBCtrlGrid]);
  dbreg.Register;
{$ENDIF}

{$IFDEF FD_REGISTER_BDE}
  bdereg.Register;
{$ENDIF}

{$IFDEF FD_REGISTER_ADO}
  adoreg.Register;
{$ENDIF}

{$IFDEF FD_REGISTER_ECONTROL_SYNTEDIT}
  ecComnReg.Register;
  ecSyntCEreg.Register;
  ecSyntReg.Register;
{$ENDIF}

{$IFDEF FD_REGISTER_ECONTROL_FORMDESIGNER}
  edReg.Register;
{$ENDIF}

{$IFDEF FD_REGISTER_DEVEX_EDITS}
  cxEditReg.Register;
  cxExtEditReg.Register;
{$ENDIF}

{$IFDEF FD_REGISTER_DEVEX_GRIDS}
  cxGridReg.Register;
  cxGridPopupMenuReg.Register;
{$ENDIF}
end;
{$ENDIF}

initialization
  StandardRegister;


end.
